package resources

import (
	"errors"
	"time"

	"cloud.o-forge.io/core/oc-lib/models/common/pricing"
	"cloud.o-forge.io/core/oc-lib/tools"
)

type PricedResource struct {
	Name                     string                      `json:"name,omitempty" bson:"name,omitempty"`
	Logo                     string                      `json:"logo,omitempty" bson:"logo,omitempty"`
	InstancesRefs            map[string]string           `json:"instances_refs,omitempty" bson:"instances_refs,omitempty"`
	PricingProfiles          []pricing.PricingProfileITF `json:"pricing_profiles,omitempty" bson:"pricing_profiles,omitempty"`
	SelectedPricing          *pricing.PricingProfileITF  `json:"selected_pricing,omitempty" bson:"selected_pricing,omitempty"`
	ExplicitBookingDurationS float64                     `json:"explicit_location_duration_s,omitempty" bson:"explicit_location_duration_s,omitempty"`
	UsageStart               *time.Time                  `json:"start,omitempty" bson:"start,omitempty"`
	UsageEnd                 *time.Time                  `json:"end,omitempty" bson:"end,omitempty"`
	CreatorID                string                      `json:"peer_id,omitempty" bson:"peer_id,omitempty"`
	ResourceID               string                      `json:"resource_id,omitempty" bson:"resource_id,omitempty"`
	ResourceType             tools.DataType              `json:"resource_type,omitempty" bson:"resource_type,omitempty"`
}

func (abs *PricedResource) GetID() string {
	return abs.ResourceID
}

func (abs *PricedResource) GetType() tools.DataType {
	return abs.ResourceType
}

func (abs *PricedResource) GetCreatorID() string {
	return abs.CreatorID
}

func (abs *PricedResource) SetStartUsage(start time.Time) {
	if abs.UsageStart == nil {
		abs.UsageStart = &start
	}
}

func (abs *PricedResource) SetEndUsage(end time.Time) {
	if abs.UsageEnd == nil {
		abs.UsageEnd = &end
	}
}

func (abs *PricedResource) IsPurchased() bool {
	if abs.SelectedPricing == nil {
		return false
	}
	return (*abs.SelectedPricing).IsPurchased()
}

func (abs *PricedResource) GetLocationEnd() *time.Time {
	return abs.UsageEnd
}

func (abs *PricedResource) GetLocationStart() *time.Time {
	return abs.UsageStart
}

func (abs *PricedResource) SetLocationStart(start time.Time) {
	abs.UsageStart = &start
}

func (abs *PricedResource) SetLocationEnd(end time.Time) {
	abs.UsageEnd = &end
}

func (abs *PricedResource) GetExplicitDurationInS() float64 {
	if abs.ExplicitBookingDurationS == 0 {
		if abs.UsageEnd == nil || abs.UsageStart == nil {
			return time.Duration(1 * time.Hour).Seconds()
		}
		return abs.UsageEnd.Sub(*abs.UsageStart).Seconds()
	}
	return abs.ExplicitBookingDurationS
}

func (r *PricedResource) GetPrice() (float64, error) {
	if r.UsageStart == nil || r.UsageEnd == nil {
		return 0, errors.New("usage start and end must be set")
	}
	if r.SelectedPricing == nil {
		return 0, errors.New("selected pricing must be set")
	}
	return (*r.SelectedPricing).GetPrice(1, 0, *r.UsageStart, *r.UsageEnd)
}
